<template>
    <div class="prk-order__container prk-order--step-five prk-order__container--shadow">
        <popupEror 
         v-if="responsEror && clousPopup" 
         :eror="responsEror"
         v-on:clous-popup="clousPopup = false;noScroll();"
        />
        <h2 class="prk-order__title">VALIDEZ VOTRE DEMANDE DE CONVOYAGE</h2>
        <ProgressForm
          :currentItem="3"
        />
        <form @submit.stop.prevent @keypress.prevent>
            <div class="prk-order__check-valid">
                <div class="row">
                    <div class="col-md-6 prk-order__check-valid-item prk-order--border-right prk-order--border-md-right">
                        <div class="prk-order__check-valid-item-inner">
                            <button class="prk-order__edit-step" @click="editStep(dataFormFirst.postFormOne.step)"></button>
                            <p class="prk-order__check-valid__title">Livraison véhicule</p>
                            <div class="prk-order__valid-content">
                                <span class="prk-order__valid-item">
                                    <span class="prk-order__data-user prk-order__data-user--date">{{dataFormTwo.date.dataStr}}</span>
                                        <span class="prk-order__data-user-label">Départ:</span>
                                     <span class="prk-order__data-user prk-order__data-user--address-from">{{dataFormFirst.postFormOne.startAddress.nameAdress}}</span>
                                        <span class="prk-order__data-user-label">Arrivée:</span>
                                     <span class="prk-order__data-user prk-order__data-user--address-to">{{dataFormFirst.postFormOne.finishAddress.nameAdress}}</span>
                                    <span class="prk-order__data-user-label">Prix:</span>
                                        <span class="prk-order__data-user prk-order__data-user--price"><strong>{{dataFormFirst.responsData.price}}</strong></span>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="col-12 d-block d-md-none">
                        <div class="prk-order__divider prk-orde__divider--light"></div>  
                    </div>
                    <div class="col-md-6 prk-order__check-valid-item prk-order--pl-md-plus">
                        <div class="prk-order__check-valid-item-inner">
                            <button class="prk-order__edit-step" @click="editStep(dataFormFour.step)"></button>
                            <p class="prk-order__check-valid__title">Véhicule</p>
                            <div class="prk-order__valid-content">
                                <span class="prk-order__valid-item">
                                    <span class="prk-order__data-user prk-order__data-user--car">{{dataFormFour.CarBrand}} {{dataFormFour.CarModel}} </span>
                                    <span class="prk-order__data-user prk-order__data-user--registration">{{dataFormFour.Registration}}</span> 
                                    <span class="prk-order__data-user prk-order__data-user--comment" v-if="dataFormFour.Comment != ''">{{dataFormFour.Comment}}</span>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="prk-order__divider prk-orde__divider--light"></div>  
                    </div>
                    <div class="col-md-6 prk-order__check-valid-item prk-order--border-right prk-order--border-md-right">
                        <div class="prk-order__check-valid-item-inner">
                            <button  class="prk-order__edit-step"  @click="editStep(dataFormThree.step)"></button>
                            <p class="prk-order__check-valid__title">Facturation</p>
                            <div class="prk-order__valid-content">
                                <span class="prk-order__valid-item">
                                    <span class="prk-order__data-user prk-order__data-user--name">{{dataFormThree.gender}}{{dataFormThree.FirstName}} {{dataFormThree.LastName}} </span>
                                    <span class="prk-order__data-user prk-order__data-user--global-address">
                                        <span class="prk-order__data-user--country">{{dataFormThree.country}}</span>,
                                        <span class="prk-order__data-user--city">{{dataFormThree.city}}</span> 
                                        <br/>
                                        <span class="prk-order__data-user--address">{{dataFormThree.Address}}</span>, 
                                        <span class="prk-order__data-user--postcode">{{dataFormThree.Postcode}}</span>
                                    </span>
                                    <span class="prk-order__data-user prk-order__data-user--phone"> Tèl : {{dataFormThree.Phone}} </span>
                                    <span class="prk-order__data-user prk-order__data-user--mail">{{dataFormThree.Mail}} </span>
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="col-12 d-block d-md-none">
                        <div class="prk-order__divider prk-orde__divider--light"></div>  
                    </div>
                    <div class="col-md-6 prk-order__check-valid-item prk-order--pl-md-plus">
                        <div class="prk-order__check-valid-item-inner">
                            <p class="prk-order__check-valid__title">Assurance</p>
                            <div class="prk-order__valid-content">
                                <span class="prk-order__valid-item">
                                    Votre véhicule est assuré jusqu’à <br/> 80 000 € par notre partenaire AXA
                                </span>
                            </div>
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="prk-order__divider prk-orde__divider--light"></div>  
                    </div>
                    <div class="col-12">
                        <p class="prk-order__check-valid__title">Personnes présentes à la livraison</p>
                        <p><em>La personne au départ (munie d’une pièce d’identité) remettra les clés et la carte grise du véhicule à notre voiturier, qui effectuera un contrôle de l’état du véhicule au départ et à l’arrivée.</em></p>   
                        <label 
                            class="prk-order__container-checkbox"
                            :class="{'prk-order__invalid--color': missingOwner && attemptSubmit}"> 
                            La personne présente au départ est le propriétaire du véhicule
                            <input 
                                @click="missingOwner;"
                                type="checkbox" 
                                name="departure_is_owner"
                                v-model="formDataObj.departure_is_owner">
                            <span class="prk-order__checkmark"></span>
                        </label>
                        <label 
                            class="prk-order__container-checkbox" 
                            :class="{'prk-order__invalid--color': missingOwner && attemptSubmit}"> 
                            La personne présente à l’arrivée est le propriétaire du véhicule
                            <input 
                                @click="missingOwner;"
                                type="checkbox" 
                                name="arrival_is_owner" 
                                v-model="formDataObj.arrival_is_owner">
                            <span class="prk-order__checkmark"></span>
                        </label>
                        <div class="prk-order__invalid" v-if="missingOwner && attemptSubmit">
                            S'il vous plaît entrez l'une des options
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="prk-order__divider prk-orde__divider--light"></div>  
                    </div>
                    <div class="col-12">
                         <p class="prk-order__check-valid__title">Engagement et conditions générales</p>
                        <div class="prk-order__conditions">
                            <div class="prk-order__conditions-list">
                                <div class="prk-order__conditions-item">
                                    <a download href="https://www.parkopoly.co/wp-content/uploads/2019/05/CGUs-Parkopoly_User_Website_2019.04.pdf ">
                                        <span class="prk-order__bg-download"></span>
                                        <span>Conditions générales de convoyage Parkopoly</span>
                                    </a>
                                </div>
                                <div class="prk-order__conditions-item">
                                    <a download href="https://www.parkopoly.co/wp-content/uploads/2019/05/CGUs-Parkopoly_User_Website_2019.04.pdf ">
                                        <span class="prk-order__bg-download"></span>
                                        <span>Conditions générales d’utilisation Parkopoly</span>
                                    </a>
                                </div>
                                <div class="prk-order__conditions-item">
                                    <a download href="https://www.parkopoly.co/wp-content/uploads/2019/05/CGUs-Parkopoly_User_Website_2019.04.pdf ">
                                        <span class="prk-order__bg-download"></span>
                                        <span>Conditions d’assurance Parkopoly</span>
                                    </a>
                                </div>
                            </div>
                        </div>
                        <label class="prk-order__container-checkbox"
                        :class="{'prk-order__invalid-checkbox': missingInvValid && attemptSubmit}"> 
                        Je certifie être le propriétaire du véhicule ou avoir le mandat du propriétaire pour planifier cette demande de convoyage, que le véhicule est assuré et correspond à la description ci-dessus.
                            <input 
                                required
                                type="checkbox" 
                                name="are_information_valid" 
                                v-model="formDataObj.are_information_valid">
                            <span class="prk-order__checkmark"></span>
                             <div class="prk-order__invalid" v-if="missingInvValid && attemptSubmit">
                                Confirmez que vous possédez une voiture
                            </div>
                        </label>

                        <label 
                            class="prk-order__container-checkbox"
                             :class="{'prk-order__invalid-checkbox': missingConditions && attemptSubmit}"> 
                            Je certifie sur l’honneur que les données renseignées sont exactes et j’accepte les conditions générales de vente, d’utilisation et la politique de confidentialité.
                            <input 
                                type="checkbox" 
                                name="are_terms_and_conditions_accepted" 
                                v-model="formDataObj.are_terms_and_conditions_accepted">
                            <span class="prk-order__checkmark"></span>
                            <div class="prk-order__invalid" v-if="missingConditions && attemptSubmit">
                                Confirmer l'accord de l'utilisateur
                            </div>
                        </label>

                        <label class="prk-order__container-checkbox"> Je souhaite continuer à recevoir des informations sur Parkopoly, sur les nouveaux services et technologies qu’ils développent
                            <input 
                                type="checkbox" 
                                name="online_order_subscribe" 
                                v-model="formDataObj.online_order_subscribe">
                            <span class="prk-order__checkmark"></span>
                        </label>
                    </div>
                </div>
            </div>
             <div class="prk-order__action">
                <button 
                type="submit"
                class="prk-order__button prk-order__button--next" 
                :disabled="loadRespons"
                :class="{'prk-order__loader':loadRespons}"
                @click="validateForm();">
                PAYER EN LIGNE</button>
            </div>
        </form>
        <div class="flex justify-content-center">
            <button  class="prk-order__button prk-order__button--no-bg prk-order__button--prev" @click="$emit('prev-step')">REVENIR</button>
        </div>
        <div class="prk-order__additional-info">
            La transaction se déroulera sur le serveur de paiement sécurisé de notre banque partenaire.
        </div>
    </div>
</template>

<script>
import ProgressForm from './ProgressForm.vue'
import popupEror from './popupEror.vue'
import axios from 'axios'

export default {
  name: 'FromStepFive',
  components: {
    ProgressForm,
    popupEror
  },
  data() {
    return {
        loadRespons: null,
        responsEror: false,
        clousPopup: false,
        formDataObj:{
          departure_is_owner:false,
          arrival_is_owner: false,
          are_information_valid: false,
          are_terms_and_conditions_accepted: false,
          online_order_subscribe: false
        },
        attemptSubmit: false,
    }
  },
  props: {
      dataFormFirst:Object,
      dataFormTwo: Object,
      dataFormThree: Object,
      dataFormFour: Object,
  },
  methods: {
    editStep(step){
        this.$emit('editStep', step)
    },
    validateForm() {
      this.attemptSubmit = true;
      if (this.missingOwner || this.missingInvValid || this.missingConditions){
         return false;
      }else{
        this.loadRespons = true; 
        axios({
          method: 'post',
          url: '/wp-admin/admin-ajax.php',
          timeout: 60000, 
          params: {
             action: 'step_5',
          },
          data: {
            body: JSON.stringify(this.formDataObj),
          }
          })
         .then(response=>{
              if(response.data.error){
                 this.responsEror = response.data.error;
                 this.clousPopup = true;
              }else{
                 this.responsEror = false;
              } 
          })
          .catch(()=>{
                this.responsEror = "Une erreur s'est produite, n'hésitez pas à contacter l'équipe Sales à contact@parkopoly.fr";
                this.clousPopup = true;
          })
          .finally(()=>{
             this.loadRespons = false;
          });
        return true;
      }
    },
    noScroll(){
       document.body.classList.remove('scroll-none');
    },
  },
  computed: {
    missingOwner(){
        return(this.formDataObj.departure_is_owner || this.formDataObj.arrival_is_owner? false : true);
    },
    missingInvValid(){
        return !this.formDataObj.are_information_valid;
    },
    missingConditions(){
        return !this.formDataObj.are_terms_and_conditions_accepted;
    },
  },
  watch: {
     loadRespons(){
        return(!this.loadRespons &&  !this.responsEror? this.$emit('next-step'):null);
     }
  },
}
</script>
<style lang="stylus">
.prk-order
    &__check-valid
        border .2px solid #707070
        padding 15px 20px
        &-item
            position relative
        &__title
           font-size 15px
           line-height 20px
           font-weight 700
           margin-bottom 10px
           color #000

    #prk-order-app &__check-valid &__divider
        margin 20px 0
        border-color #cecece

    &__check-valid &--border-md-right:after
        background #cecece

    /*Button edit step */
    &__edit-step
        position absolute
        right 20px
        border-radius 50%
        width 30px
        height 30px
        transition ease .5s
        border none
        background url("/wp-content/mu-plugins/online-order/assets/img/bg_step_edit.svg") center / cover no-repeat
        &:hover
            transform scale3d(1.2, 1.2, 1.2)
        &:focus
            outline none
            transform scale3d(1.2, 1.2, 1.2)
    /* user data*/
    &__data-user
        display block
        line-height 19px
     /*conditions-list*/   
    &__conditions
        margin-bottom 40px
        &-list
            display flex
            justify-content space-around
            flex-wrap wrap
            background #E9E9E9
            border-radius 3px
            padding 12px 0
        &-item
            width 100%
            text-align center
            padding 0 15px 
            & a
                color #000
                font-size 12px
    &__bg-download
        background  url("http://parkopoly.wp4u.tech/wp-content/mu-plugins/online-order/assets/img/download.svg")
        border-radius 50%
        width 34px
        height 34px
        display block
        margin 0 auto 10px
        transition ease .5s
        &:hover
            transform scale3d(1.2, 1.2, 1.2)
        &:focus
            outline none
            transform scale3d(1.2, 1.2, 1.2)
    &__additional-info
        font-size 12px
        text-align center
        margin auto
        max-width 215px
        position relative
        &:before
            content ""
            position absolute
            width 20px
            height 23px
            background url(/wp-content/mu-plugins/online-order/assets/img/security.svg) no-repeat
            left -20px
@media (min-width: 480px)
    .prk-order    
        &__additional-info
            max-width 350px
@media (min-width:768px)
    .prk-order
        &--pl-md-plus
            padding-left 30px
        &__conditions
            &-item
                max-width: 33.33333%;
                flex: 0 0 33.33333%;

@media (min-width:992px)
    .prk-order
        &__conditions
            &-item
                max-width: 170px;
                flex: 0 0 170px;

</style>